using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.IO;
using System.Globalization;

namespace SVVClient_cs
{
    class Program
    {
        static void event_loop(TcpClient cli, StreamReader reader, StreamWriter writer)
        {
            try
            {
                Igralec t;
                Polje polje;
                string cmd;
                string[] cmda;
                char[] delimiter = new char[] { ' ' };

                while (true)
                {
                    cmd = reader.ReadLine();
                    cmda = cmd.Split(delimiter);

                    if (cmda[0] == "ADIJO") return;
                    if (cmda[0].StartsWith("KONEC_IGRE")) continue;
                    if (cmda[0] != "ZBUDI_SE") throw new Exception("Napaka pri komunikaciji s streznikom.");

                    int[] cmdi = new int[cmda.Length - 1];
                    for (int i = 0; i < cmdi.Length; i++)
                    {
                        cmdi[i] = Int32.Parse(cmda[i + 1], CultureInfo.InvariantCulture);
                    }

                    int w = cmdi[0];
                    int h = cmdi[1];
                    bool zacnem = cmdi[2] == 0;

                    polje = new Polje(w, h);
                    t = new Igralec();
                    t.ZbudiSe(w, h, zacnem);

                    writer.WriteLine("BUDEN");

                    while (true)
                    {
                        cmd = reader.ReadLine();
                        cmda = cmd.Split(delimiter);

                        if (cmda[0] == "ADIJO") return;
                        if (cmda[0] == "KONEC_IGRE")
                        {
                            razlog r = (razlog)(Int32.Parse(cmda[1]));
                            t.KonecIgre(r);
                            t = null;
                            polje = null;
                            break;
                        }
                        else if (cmda[0] == "QV")
                        {
                            int prejsnja_poteza = Int32.Parse(cmda[1]);
                            polje.dodaj(prejsnja_poteza, barva.bNasprotnik);
                            int stolpec = t.KamGres(new Polje(polje), prejsnja_poteza);
                            polje.dodaj(stolpec, barva.bJaz);
                            writer.WriteLine("QVR " + stolpec.ToString());
                        }
                        else
                        {
                        }
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("Napaka: " + e.ToString());
            }
        }

        static TcpClient connect(string hostname, out StreamReader reader, out StreamWriter writer)
        {
            TcpClient client = new TcpClient(hostname, 1177);
            reader = new StreamReader(client.GetStream());
            writer = new StreamWriter(client.GetStream());
            writer.AutoFlush = true;

            string server = reader.ReadLine();
            Console.WriteLine(server);

            writer.WriteLine("AVE " + Igralec.Ime);
            string succ = reader.ReadLine();
            if (succ != "PRIJAVA USPESNA") throw new Exception("Prijava na streznik neuspesna: " + succ);
            return client;
        }

        static void Main(string[] args)
        {
            string hostname;
            if (args.Length < 1) hostname = "localhost";
            else hostname = args[0];

            StreamReader reader;
            StreamWriter writer;
            TcpClient client = connect(hostname, out reader, out writer);
            event_loop(client, reader, writer);
        }
    }
}
